import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;

/**
 * Zeigt die Teilnehmerliste an
 * @author Martin
 *
 */
public class View extends JFrame implements Observer {

	private static final long serialVersionUID = 1L;
	private Controller controller;
	private DefaultListModel listmodel = new DefaultListModel<>();

	public View(final Controller controller) {

		this.controller = controller;
		
		setTitle("Teilnehmerliste");
		setSize(300, 500);
		setLocation(200, 200);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		JList liste = new JList(listmodel);
		JButton button = new JButton("Teilnehmer hinzufgen");

		button.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {

				String name = JOptionPane.showInputDialog(null,
						"Namen eingeben", "Neuer Teilnehmer");
				
				controller.addTeilnehmer(name);

			}
		});

		setLayout(new BorderLayout());

		add(liste, BorderLayout.CENTER);
		add(button, BorderLayout.SOUTH);

		setVisible(true);

	}

	@Override
	public void update(Observable arg0, Object arg1) {
		listmodel.removeAllElements();
		ArrayList<String> namen = controller.getNamen();
		for (int i = 0; i < namen.size(); i++) {
			listmodel.addElement(namen.get(i));
		}
		
	}

}
